Prime Path POJ - 3126

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0
#include<stdio.h>
#include<iostream>
#include<algorithm>
#include<cstring>
#include<queue>
#include<math.h>
using namespace std;
bool vis[10000];

struct Node {
    int a, step;
};

Node u, v;

bool judge(int num) {
    for (int i = 2; i <= sqrt(num); i++) {
        if (num%i == 0)return false;
    }
    return true;
}

void bfs() {
    queue<struct Node> q;
    u.step == 0;
    vis[u.a] = 1;
    q.push(u);
    int i;
    while (!q.empty()) {
        struct Node temp;
        temp = q.front();
        q.pop();
        if (temp.a == v.a) { printf("%d\n", temp.step); return; }
        for (i = 1; i <= 9; i += 2) //个位
        {
            int s = temp.a / 10 * 10 + i;
            if (s != temp.a && !vis[s] && judge(s))
            {
                vis[s] = 1;
                Node t;
                t.a = s;
                t.step = temp.step + 1;
                q.push(t);
            }
        }
        for (i = 0; i <= 9; i++) //十位
        {
            int s = temp.a / 100 * 100 + i * 10 + temp.a % 10;
            if (s != temp.a && !vis[s] && judge(s))
            {
                vis[s] = 1;
                Node t;
                t.a = s;
                t.step = temp.step + 1;
                q.push(t);
            }
        }
        for (i = 0; i <= 9; i++) //百位
        {
            int s = temp.a / 1000 * 1000 + i * 100 + temp.a % 100;
            if (s != temp.a && !vis[s] && judge(s))
            {
                vis[s] = 1;
                Node t;
                t.a = s;
                t.step = temp.step + 1;
                q.push(t);
            }
        }
        for (i = 1; i <= 9; i++) //千位
        {
            int s = i * 1000 + temp.a % 1000;
            if (s != temp.a && !vis[s] && judge(s))
            {
                vis[s] = 1;
                Node t;
                t.a = s;
                t.step = temp.step + 1;
                q.push(t);
            }
        }
    }
    printf("Impossible\n");
    return;
}

int main() {
    int k;
    cin >> k;
    while (k--) {
        memset(vis, 0, sizeof vis);
        cin >> u.a >> v.a;
        bfs();
    }
    return 0;
}

猜你喜欢

转载自www.cnblogs.com/CuteAbacus/p/9492141.html